summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--lib/completion.zsh2
-rw-r--r--lib/key-bindings.zsh5
-rw-r--r--oh-my-zsh.sh13
-rw-r--r--plugins/bundler/bundler.plugin.zsh2
-rw-r--r--plugins/git/git.plugin.zsh4
-rw-r--r--plugins/heroku/_heroku158
-rw-r--r--plugins/lol/lol.plugin.zsh11
-rw-r--r--plugins/npm/_npm19
-rw-r--r--plugins/npm/npm.plugin.zsh1
-rw-r--r--plugins/python/python.plugin.zsh5
-rw-r--r--templates/zshrc.zsh-template4
-rw-r--r--themes/norm.zsh-theme4
-rwxr-xr-xtools/require_tool.sh161
13 files changed, 363 insertions, 26 deletions
diff --git a/lib/completion.zsh b/lib/completion.zsh
index 2a457402a..b3cc91822 100644
--- a/lib/completion.zsh
+++ b/lib/completion.zsh
@@ -59,7 +59,7 @@ zstyle ':completion:*:*:*:users' ignored-patterns \
# ... unless we really want to.
zstyle '*' single-ignored show
-if [ "$DISABLE_COMPLETION_WAITING_DOTS" != "true" ]; then
+if [ "x$COMPLETION_WAITING_DOTS" = "xtrue" ]; then
expand-or-complete-with-dots() {
echo -n "\e[31m......\e[0m"
zle expand-or-complete
diff --git a/lib/key-bindings.zsh b/lib/key-bindings.zsh
index 9c2dda35a..5c1b90bfa 100644
--- a/lib/key-bindings.zsh
+++ b/lib/key-bindings.zsh
@@ -14,10 +14,15 @@ bindkey '^[[B' down-line-or-search
bindkey "^[[H" beginning-of-line
bindkey "^[[1~" beginning-of-line
+bindkey "^[OH" beginning-of-line
bindkey "^[[F" end-of-line
bindkey "^[[4~" end-of-line
+bindkey "^[OF" end-of-line
bindkey ' ' magic-space # also do history expansion on space
+bindkey "^[[1;5C" forward-word
+bindkey "^[[1;5D" backward-word
+
bindkey '^[[Z' reverse-menu-complete
# Make the delete key (or Fn + Delete on the Mac) work instead of outputting a ~
diff --git a/oh-my-zsh.sh b/oh-my-zsh.sh
index c4522491b..3865abe17 100644
--- a/oh-my-zsh.sh
+++ b/oh-my-zsh.sh
@@ -21,17 +21,24 @@ for plugin ($plugins) fpath=($ZSH/plugins/$plugin $fpath)
autoload -U compinit
compinit -i
+# Set ZSH_CUSTOM to the path where your custom config files
+# and plugins exists, or else we will use the default custom/
+if [ "$ZSH_CUSTOM" = "" ]
+then
+ ZSH_CUSTOM="$ZSH/custom"
+fi
+
# Load all of the plugins that were defined in ~/.zshrc
for plugin ($plugins); do
- if [ -f $ZSH/custom/plugins/$plugin/$plugin.plugin.zsh ]; then
- source $ZSH/custom/plugins/$plugin/$plugin.plugin.zsh
+ if [ -f $ZSH_CUSTOM/plugins/$plugin/$plugin.plugin.zsh ]; then
+ source $ZSH_CUSTOM/plugins/$plugin/$plugin.plugin.zsh
elif [ -f $ZSH/plugins/$plugin/$plugin.plugin.zsh ]; then
source $ZSH/plugins/$plugin/$plugin.plugin.zsh
fi
done
# Load all of your custom configurations from custom/
-for config_file ($ZSH/custom/*.zsh) source $config_file
+for config_file ($ZSH_CUSTOM/*.zsh) source $config_file
# Load the theme
if [ "$ZSH_THEME" = "random" ]
diff --git a/plugins/bundler/bundler.plugin.zsh b/plugins/bundler/bundler.plugin.zsh
index f005700ff..a6c116407 100644
--- a/plugins/bundler/bundler.plugin.zsh
+++ b/plugins/bundler/bundler.plugin.zsh
@@ -6,7 +6,7 @@ alias bp="bundle package"
# The following is based on https://github.com/gma/bundler-exec
-bundled_commands=(cap capify cucumber heroku rackup rails rake rspec ruby shotgun spec spork thin unicorn unicorn_rails)
+bundled_commands=(cap capify cucumber guard heroku rackup rails rake rspec ruby shotgun spec spork thin unicorn unicorn_rails)
## Functions
diff --git a/plugins/git/git.plugin.zsh b/plugins/git/git.plugin.zsh
index 5132b639a..4fcf9425d 100644
--- a/plugins/git/git.plugin.zsh
+++ b/plugins/git/git.plugin.zsh
@@ -29,6 +29,10 @@ alias glg='git log --stat --max-count=5'
compdef _git glg=git-log
alias glgg='git log --graph --max-count=5'
compdef _git glgg=git-log
+alias gss='git status -s'
+compdef _git gss=git-status
+alias ga='git add'
+compdef _git ga=git-add
# Git and svn mix
alias git-svn-dcommit-push='git svn dcommit && git push github master:svntrunk'
diff --git a/plugins/heroku/_heroku b/plugins/heroku/_heroku
new file mode 100644
index 000000000..dc899e2b2
--- /dev/null
+++ b/plugins/heroku/_heroku
@@ -0,0 +1,158 @@
+#compdef heroku
+
+# Heroku Autocomplete plugin for Oh-My-Zsh
+# Requires: The Heroku client gem (https://github.com/heroku/heroku)
+# Author: Ali B. (http://awhitebox.com)
+
+local -a _1st_arguments
+_1st_arguments=(
+ "account\:confirm_billing":"Confirm that your account can be billed at the end of the month"
+ "addons":"list installed addons"
+ "addons\:list":"list all available addons"
+ "addons\:add":"install an addon"
+ "addons\:upgrade":"upgrade an existing addon"
+ "addons\:downgrade":"downgrade an existing addon"
+ "addons\:remove":"uninstall an addon"
+ "addons\:open":"open an addon's dashboard in your browser"
+ "apps":"list your apps"
+ "apps\:info":"show detailed app information"
+ "apps\:create":"create a new app"
+ "apps\:rename":"rename the app"
+ "apps\:open":"open the app in a web browser"
+ "apps\:destroy":"permanently destroy an app"
+ "auth\:login":"log in with your heroku credentials"
+ "auth\:logout":"clear local authentication credentials"
+ "config":"display the config vars for an app"
+ "config\:add":"add one or more config vars"
+ "config\:remove":"remove a config var"
+ "db\:push":"push local data up to your app"
+ "db\:pull":"pull heroku data down into your local database"
+ "domains":"list custom domains for an app"
+ "domains\:add":"add a custom domain to an app"
+ "domains\:remove":"remove a custom domain from an app"
+ "domains\:clear":"remove all custom domains from an app"
+ "help":"list available commands or display help for a specific command"
+ "keys":"display keys for the current user"
+ "keys\:add":"add a key for the current user"
+ "keys\:remove":"remove a key from the current user"
+ "keys\:clear":"remove all authentication keys from the current user"
+ "logs":"display recent log output"
+ "logs\:cron":"DEPRECATED: display cron logs from legacy logging"
+ "logs\:drains":"manage syslog drains"
+ "maintenance\:on":"put the app into maintenance mode"
+ "maintenance\:off":"take the app out of maintenance mode"
+ "pg\:info":"display database information"
+ "pg\:ingress":"allow direct connections to the database from this IP for one minute"
+ "pg\:promote":"sets DATABASE as your DATABASE_URL"
+ "pg\:psql":"open a psql shell to the database"
+ "pg\:reset":"delete all data in DATABASE"
+ "pg\:unfollow":"stop a replica from following and make it a read/write database"
+ "pg\:wait":"monitor database creation, exit when complete"
+ "pgbackups":"list captured backups"
+ "pgbackups\:url":"get a temporary URL for a backup"
+ "pgbackups\:capture":"capture a backup from a database id"
+ "pgbackups\:restore":"restore a backup to a database"
+ "pgbackups\:destroy":"destroys a backup"
+ "plugins":"list installed plugins"
+ "plugins\:install":"install a plugin"
+ "plugins\:uninstall":"uninstall a plugin"
+ "ps\:dynos":"scale to QTY web processes"
+ "ps\:workers":"scale to QTY background processes"
+ "ps":"list processes for an app"
+ "ps\:restart":"restart an app process"
+ "ps\:scale":"scale processes by the given amount"
+ "releases":"list releases"
+ "releases\:info":"view detailed information for a release"
+ "rollback":"roll back to an older release"
+ "run":"run an attached process"
+ "run\:rake":"remotely execute a rake command"
+ "run\:console":"open a remote console session"
+ "sharing":"list collaborators on an app"
+ "sharing\:add":"add a collaborator to an app"
+ "sharing\:remove":"remove a collaborator from an app"
+ "sharing\:transfer":"transfer an app to a new owner"
+ "ssl":"list certificates for an app"
+ "ssl\:add":"add an ssl certificate to an app"
+ "ssl\:remove":"remove an ssl certificate from an app"
+ "ssl\:clear":"remove all ssl certificates from an app"
+ "stack":"show the list of available stacks"
+ "stack\:migrate":"prepare migration of this app to a new stack"
+ "version":"show heroku client version"
+)
+
+_arguments '*:: :->command'
+
+if (( CURRENT == 1 )); then
+ _describe -t commands "heroku command" _1st_arguments
+ return
+fi
+
+local -a _command_args
+case "$words[1]" in
+ apps:info)
+ _command_args=(
+ '(-r|--raw)'{-r,--raw}'[output info as raw key/value pairs]' \
+ )
+ ;;
+ apps:create)
+ _command_args=(
+ '(-a|--addons)'{-a,--addons}'[a list of addons to install]' \
+ '(-r|--remote)'{-r,--remote}'[the git remote to create, default "heroku"]' \
+ '(-s|--stack)'{-s,--stack}'[the stack on which to create the app]' \
+ )
+ ;;
+ config)
+ _command_args=(
+ '(-s|--shell)'{-s,--shell}'[output config vars in shell format]' \
+ )
+ ;;
+ db:push)
+ _command_args=(
+ '(-c|--chunksize)'{-c,--chunksize}'[specify the number of rows to send in each batch]' \
+ '(-d|--debug)'{-d,--debug}'[enable debugging output]' \
+ '(-e|--exclude)'{-e,--exclude}'[exclude the specified tables from the push]' \
+ '(-f|--filter)'{-f,--filter}'[only push certain tables]' \
+ '(-r|--resume)'{-r,--resume}'[resume transfer described by a .dat file]' \
+ '(-t|--tables)'{-t,--tables}'[only push the specified tables]' \
+ )
+ ;;
+ db:pull)
+ _command_args=(
+ '(-c|--chunksize)'{-c,--chunksize}'[specify the number of rows to send in each batch]' \
+ '(-d|--debug)'{-d,--debug}'[enable debugging output]' \
+ '(-e|--exclude)'{-e,--exclude}'[exclude the specified tables from the pull]' \
+ '(-f|--filter)'{-f,--filter}'[only pull certain tables]' \
+ '(-r|--resume)'{-r,--resume}'[resume transfer described by a .dat file]' \
+ '(-t|--tables)'{-t,--tables}'[only pull the specified tables]' \
+ )
+ ;;
+ keys)
+ _command_args=(
+ '(-l|--long)'{-l,--long}'[display extended information for each key]' \
+ )
+ ;;
+ logs)
+ _command_args=(
+ '(-n|--num)'{-n,--num}'[the number of lines to display]' \
+ '(-p|--ps)'{-p,--ps}'[only display logs from the given process]' \
+ '(-s|--source)'{-s,--source}'[only display logs from the given source]' \
+ '(-t|--tail)'{-t,--tail}'[continually stream logs]' \
+ )
+ ;;
+ pgbackups:capture)
+ _command_args=(
+ '(-e|--expire)'{-e,--expire}'[if no slots are available to capture, delete the oldest backup to make room]' \
+ )
+ ;;
+ stack)
+ _command_args=(
+ '(-a|--all)'{-a,--all}'[include deprecated stacks]' \
+ )
+ ;;
+ esac
+
+_arguments \
+ $_command_args \
+ '(--app)--app[the app name]' \
+ && return 0
+
diff --git a/plugins/lol/lol.plugin.zsh b/plugins/lol/lol.plugin.zsh
index a7153bb57..e455527e7 100644
--- a/plugins/lol/lol.plugin.zsh
+++ b/plugins/lol/lol.plugin.zsh
@@ -8,19 +8,30 @@ alias rtfm='man'
alias visible='echo'
alias invisible='cat'
alias moar='more'
+alias tldr='less'
+alias alwayz='tail -f'
alias icanhas='mkdir'
+alias gimmeh='touch'
alias donotwant='rm'
alias dowant='cp'
alias gtfo='mv'
+alias nowai='chmod'
alias hai='cd'
+alias iz='ls'
alias plz='pwd'
+alias ihasbucket='df -h'
alias inur='locate'
+alias iminurbase='finger'
+
+alias btw='nice'
+alias obtw='nohup'
alias nomz='ps -aux'
alias nomnom='killall'
+alias byes='exit'
alias cya='reboot'
alias kthxbai='halt'
diff --git a/plugins/npm/_npm b/plugins/npm/_npm
deleted file mode 100644
index 24b536188..000000000
--- a/plugins/npm/_npm
+++ /dev/null
@@ -1,19 +0,0 @@
-#compdef npm
-
-# Node Package Manager 0.3.15 completion, letting npm do all the completion work
-
-_npm() {
- compadd -- $(_npm_complete $words)
-}
-
-# We want to show all errors of any substance, but never the "npm (not )ok" one.
-# (Also doesn't consider "ERR! no match found" worth breaking the terminal for.)
-_npm_complete() {
- local ask_npm
- ask_npm=(npm completion --color false --loglevel error -- $@)
- { _call_program npm $ask_npm 2>&1 >&3 \
- | egrep -v '^(npm (not |)ok|ERR! no match found)$' >&2; \
- } 3>&1
-}
-
-_npm "$@"
diff --git a/plugins/npm/npm.plugin.zsh b/plugins/npm/npm.plugin.zsh
new file mode 100644
index 000000000..c3eb91d31
--- /dev/null
+++ b/plugins/npm/npm.plugin.zsh
@@ -0,0 +1 @@
+eval "$(npm completion 2>/dev/null)"
diff --git a/plugins/python/python.plugin.zsh b/plugins/python/python.plugin.zsh
new file mode 100644
index 000000000..3ea34d718
--- /dev/null
+++ b/plugins/python/python.plugin.zsh
@@ -0,0 +1,5 @@
+# Find python file
+alias pyfind='find . -name "*.py"'
+
+# Remove python compiled byte-code
+alias pyclean='find . -type f -name "*.py[co]" -exec rm -f \{\} \;'
diff --git a/templates/zshrc.zsh-template b/templates/zshrc.zsh-template
index 4de1fa4e9..1ab40aba6 100644
--- a/templates/zshrc.zsh-template
+++ b/templates/zshrc.zsh-template
@@ -19,8 +19,8 @@ ZSH_THEME="robbyrussell"
# Uncomment following line if you want to disable autosetting terminal title.
# DISABLE_AUTO_TITLE="true"
-# Uncomment following line if you want disable red dots displayed while waiting for completion
-# DISABLE_COMPLETION_WAITING_DOTS="true"
+# Uncomment following line if you want red dots to be displayed while waiting for completion
+# COMPLETION_WAITING_DOTS="true"
# Which plugins would you like to load? (plugins can be found in ~/.oh-my-zsh/plugins/*)
# Example format: plugins=(rails git textmate ruby lighthouse)
diff --git a/themes/norm.zsh-theme b/themes/norm.zsh-theme
new file mode 100644
index 000000000..5f0ad03ee
--- /dev/null
+++ b/themes/norm.zsh-theme
@@ -0,0 +1,4 @@
+PROMPT='%{$fg[yellow]%}λ %{$fg[green]%}%c %{$fg[yellow]%}→ $(git_prompt_info)%{$reset_color%}'
+
+ZSH_THEME_GIT_PROMPT_PREFIX="λ %{$fg[blue]%}git %{$fg[red]%}"
+ZSH_THEME_GIT_PROMPT_SUFFIX="%{$fg[yellow]%} → %{$reset_color%}"
diff --git a/tools/require_tool.sh b/tools/require_tool.sh
new file mode 100755
index 000000000..1fa77f77a
--- /dev/null
+++ b/tools/require_tool.sh
@@ -0,0 +1,161 @@
+__require_tool_version_compare ()
+{
+ (
+ # Locally ignore failures, otherwise we'll exit whenever $1 and $2
+ # are not equal!
+ set +e
+
+awk_strverscmp='
+ # Use only awk features that work with 7th edition Unix awk (1978).
+ # My, what an old awk you have, Mr. Solaris!
+ END {
+ while (length(v1) || length(v2)) {
+ # Set d1 to be the next thing to compare from v1, and likewise for d2.
+ # Normally this is a single character, but if v1 and v2 contain digits,
+ # compare them as integers and fractions as strverscmp does.
+ if (v1 ~ /^[0-9]/ && v2 ~ /^[0-9]/) {
+ # Split v1 and v2 into their leading digit string components d1 and d2,
+ # and advance v1 and v2 past the leading digit strings.
+ for (len1 = 1; substr(v1, len1 + 1) ~ /^[0-9]/; len1++) continue
+ for (len2 = 1; substr(v2, len2 + 1) ~ /^[0-9]/; len2++) continue
+ d1 = substr(v1, 1, len1); v1 = substr(v1, len1 + 1)
+ d2 = substr(v2, 1, len2); v2 = substr(v2, len2 + 1)
+ if (d1 ~ /^0/) {
+ if (d2 ~ /^0/) {
+ # Compare two fractions.
+ while (d1 ~ /^0/ && d2 ~ /^0/) {
+ d1 = substr(d1, 2); len1--
+ d2 = substr(d2, 2); len2--
+ }
+ if (len1 != len2 && ! (len1 && len2 && substr(d1, 1, 1) == substr(d2, 1, 1))) {
+ # The two components differ in length, and the common prefix
+ # contains only leading zeros. Consider the longer to be less.
+ d1 = -len1
+ d2 = -len2
+ } else {
+ # Otherwise, compare as strings.
+ d1 = "x" d1
+ d2 = "x" d2
+ }
+ } else {
+ # A fraction is less than an integer.
+ exit 1
+ }
+ } else {
+ if (d2 ~ /^0/) {
+ # An integer is greater than a fraction.
+ exit 2
+ } else {
+ # Compare two integers.
+ d1 += 0
+ d2 += 0
+ }
+ }
+ } else {
+ # The normal case, without worrying about digits.
+ if (v1 == "") d1 = v1; else { d1 = substr(v1, 1, 1); v1 = substr(v1,2) }
+ if (v2 == "") d2 = v2; else { d2 = substr(v2, 1, 1); v2 = substr(v2,2) }
+ }
+ if (d1 < d2) exit 1
+ if (d1 > d2) exit 2
+ }
+ }
+'
+ awk "$awk_strverscmp" v1="$1" v2="$2" /dev/null
+ case $? in
+ 1) echo '<';;
+ 0) echo '=';;
+ 2) echo '>';;
+ esac
+ )
+}
+
+
+__require_tool_fatal ()
+{
+ echo $@ >/dev/stderr
+ return 1
+}
+
+# Usage: require_tool program version
+# Returns: 0 if $1 version if greater equals than $2, 1 otherwise.
+# In case of error, message is written on error output.
+#
+# Example: require_tool gcc 4.6
+# Use GCC environment variable if defined instead of lookup for the tool
+# in the environment.
+require_tool ()
+{
+ envvar_name=$(echo $1 | tr '[:lower:]' '[:upper:]')
+ tool=$(printenv $envvar_name || echo $1)
+ local version=$($tool --version 2>/dev/null| \
+ sed -n 's/.*[^0-9.]\([0-9]*\.[0-9.]*\).*/\1/p;q')
+ if test x"$version" = x ; then
+ echo "$tool is required" >/dev/stderr
+ return 1
+ fi
+ case $(__require_tool_version_compare "$2" "$version") in
+ '>')
+ echo "$1 $2 or better is required: this is $tool $version" >/dev/stderr
+ return 1
+ ;;
+ esac
+}
+
+usage() {
+ cat <<EOF
+NAME
+ require_tool.sh - Ensure version of a tool is greater than the one expected
+
+SYNOPSYS
+ require_tool.sh [ -h ]
+ [ --help ]
+ [ TOOL MIN_VERSION ]
+
+DESCRIPTION
+ TOOL is the name or path of the program to check. If the name is specified, its
+ path is deduced from PATH environment variable. If environment variable TOOL
+ (in upper-case characters) is defined, considers its value as path to the tool.
+
+ MIN_VERSION is a string representing the minimum required version.
+
+BEHAVIOR
+ * locate path to the program.
+ * execute $ TOOL_PATH --version
+ * extract version from standard output.
+ * compare this version to the expected one.
+
+OPTIONS
+ -h --help
+ Display this message and exit 0
+
+ERRORS
+ if program is not found or its version is prior to expected version,
+ a message is written to error output.
+
+EXIT VALUE
+ returns 0 if program version if greater equals than expected version,
+ returns 1 otherwise.
+
+EXAMPLE
+ $ require_tool.sh emacs 23
+ $ CC=g++ require_tool.sh cc 4.6
+ $ require_tool.sh zsh 4.5
+
+EOF
+}
+
+for arg in $@; do
+ case $arg in
+ -h|--help)
+ usage
+ exit 0
+ ;;
+ esac
+done
+if [ $# -gt 2 ] ; then
+ echo "ERROR: expecting 2 parameters. Please see option --help"
+ exit 1
+fi
+
+require_tool $@